/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/
package se.kth.md.assume.adaptors.gitlab.services;

import org.eclipse.lyo.oslc4j.core.annotation.OslcDialog;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import se.kth.md.assume.adaptors.gitlab.GitLabConstants;
import se.kth.md.assume.adaptors.gitlab.GitLabManager;
import se.kth.md.assume.adaptors.gitlab.resources.FileResource;
import se.kth.md.assume.adaptors.gitlab.resources.FolderResource;
import se.kth.md.assume.adaptors.gitlab.resources.VersionResource;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.List;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code
@OslcService(GitLabConstants.FILE_MANAGEMENT_DOMAIN)
@Path("fm-services/{serviceProviderId}/resources")
public class FileResourceAndFolderResourceAndVersionResourceService
{
    @Context private HttpServletRequest httpServletRequest;
    @Context private HttpServletResponse httpServletResponse;
    @Context private UriInfo uriInfo;

    // Start of user code class_attributes
    // End of user code

    // Start of user code class_methods
    // End of user code

    public FileResourceAndFolderResourceAndVersionResourceService()
    {
        super();
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityVR",
        label = "QueryCapabilityVersions",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + GitLabConstants.PATH_VERSIONRESOURCE,
        resourceTypes = {GitLabConstants.TYPE_VERSIONRESOURCE},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("queryversionresources")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public VersionResource[] queryVersionResources(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryVersionResources
        // Here additional logic can be implemented that complements main action taken in GitLabManager
        // End of user code

        final List<VersionResource> resources = GitLabManager.queryVersionResources(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new VersionResource [resources.size()]);
    }

    @GET
    @Path("queryversionresources")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryVersionResourcesAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryVersionResourcesAsHtml
        // End of user code

        final List<VersionResource> resources = GitLabManager.queryVersionResources(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryVersionResourcesAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/queryresults-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityFR",
        label = "QueryCapabilityFileResources",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + GitLabConstants.PATH_FILERESOURCE,
        resourceTypes = {GitLabConstants.TYPE_FILERESOURCE},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("queryfileresources")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public FileResource[] queryFileResources(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryFileResources
        // Here additional logic can be implemented that complements main action taken in GitLabManager
        // End of user code

        final List<FileResource> resources = GitLabManager.queryFileResources(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new FileResource [resources.size()]);
    }

    @GET
    @Path("queryfileresources")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryFileResourcesAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryFileResourcesAsHtml
        // End of user code

        final List<FileResource> resources = GitLabManager.queryFileResources(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryFileResourcesAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/queryresults-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityFoldR",
        label = "QueryCapabilityFoldR",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + GitLabConstants.PATH_FOLDERRESOURCE,
        resourceTypes = {GitLabConstants.TYPE_FOLDERRESOURCE},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("queryfolderresources")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public FolderResource[] queryFolderResources(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryFolderResources
        // Here additional logic can be implemented that complements main action taken in GitLabManager
        // End of user code

        final List<FolderResource> resources = GitLabManager.queryFolderResources(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new FolderResource [resources.size()]);
    }

    @GET
    @Path("queryfolderresources")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryFolderResourcesAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryFolderResourcesAsHtml
        // End of user code

        final List<FolderResource> resources = GitLabManager.queryFolderResources(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryFolderResourcesAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/queryresults-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcDialog
    (
         title = "SelectionDialogFileResource",
         label = "SelectionDialogFileResource",
         uri = "fm-services/{serviceProviderId}/resources/fileresourceSelector",
         hintWidth = "0px",
         hintHeight = "0px",
         resourceTypes = {GitLabConstants.TYPE_FILERESOURCE},
         usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("fileresourceSelector")
    @Consumes({ MediaType.TEXT_HTML, MediaType.WILDCARD })
    public void FileResourceSelector(
        @QueryParam("terms") final String terms
        , @PathParam("serviceProviderId") final String serviceProviderId
        ) throws ServletException, IOException
    {
        try {
            // Start of user code FileResourceSelector_init
            // End of user code

            httpServletRequest.setAttribute("selectionUri",uriInfo.getAbsolutePath().toString());
            // Start of user code FileResourceSelector_setAttributes
            // End of user code

            if (terms != null ) {
                httpServletRequest.setAttribute("terms", terms);
                final List<FileResource> resources = GitLabManager.FileResourceSelector(httpServletRequest, serviceProviderId, terms);
                if (resources!= null) {
                            httpServletRequest.setAttribute("resources", resources);
                            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/fileresourceselectorresults.jsp");
                            rd.forward(httpServletRequest, httpServletResponse);
                }
                //a empty search should return an empty list and not NULL!
                throw new WebApplicationException(Status.NOT_FOUND);

            } else {
                try {
                    RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/fileresourceselector.jsp");
                    rd.forward(httpServletRequest, httpServletResponse);
                } catch (Exception e) {
                    throw new ServletException(e);
                }
            }
        } catch (Exception e) {
            throw new WebApplicationException(e);
        }
    }

    @GET
    @Path("versionResources/{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public VersionResource getVersionResource(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final VersionResource aVersionResource = GitLabManager.getVersionResource(httpServletRequest, serviceProviderId, resourceId);

        if (aVersionResource != null) {
            // Start of user code getVersionResource
            // End of user code
            return aVersionResource;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("versionResources/{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getVersionResourceAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getVersionResourceAsHtml_init
        // End of user code

        final VersionResource aVersionResource = GitLabManager.getVersionResource(httpServletRequest, serviceProviderId, resourceId);

        if (aVersionResource != null) {
            httpServletRequest.setAttribute("aVersionResource", aVersionResource);
            // Start of user code getVersionResourceAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/resourcepresentation-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("fileResources/{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public FileResource getFileResource(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final FileResource aFileResource = GitLabManager.getFileResource(httpServletRequest, serviceProviderId, resourceId);

        if (aFileResource != null) {
            // Start of user code getFileResource
            // End of user code
            return aFileResource;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("fileResources/{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getFileResourceAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getFileResourceAsHtml_init
        // End of user code

        final FileResource aFileResource = GitLabManager.getFileResource(httpServletRequest, serviceProviderId, resourceId);

        if (aFileResource != null) {
            httpServletRequest.setAttribute("aFileResource", aFileResource);
            // Start of user code getFileResourceAsHtml_setAttributes
            httpServletRequest.setAttribute("abstractResource", (AbstractResource)aFileResource);
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/resourcepresentation-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("folderResources/{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public FolderResource getFolderResource(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final FolderResource aFolderResource = GitLabManager.getFolderResource(httpServletRequest, serviceProviderId, resourceId);

        if (aFolderResource != null) {
            // Start of user code getFolderResource
            // End of user code
            return aFolderResource;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("folderResources/{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getFolderResourceAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getFolderResourceAsHtml_init
        // End of user code

        final FolderResource aFolderResource = GitLabManager.getFolderResource(httpServletRequest, serviceProviderId, resourceId);

        if (aFolderResource != null) {
            httpServletRequest.setAttribute("aFolderResource", aFolderResource);
            // Start of user code getFolderResourceAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/resourcepresentation-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

}
